import { createRouter, createWebHistory, RouteRecordRaw } from 'vue-router';
import Home from '@/views/home/Home.vue';
import { isLogin } from '@/utils';

const routes: Array<RouteRecordRaw> = [
  {
    path: '/',
    name: 'Home',
    component: Home,
  },
  {
    path: '/about',
    name: 'About',
    component: () =>
      import(/* webpackChunkName: "about" */ '../views/about/About.vue'),
    meta: {
      auth: true,
    },
  },
  {
    path: '/:pathMatch(.*)*',
    component: () =>
      import(/* webpackChunkName: "404" */ '../views/404/PageNotFound.vue'),
  },
];

const router = createRouter({
  history: createWebHistory('<%= appName %>'),
  routes,
});

router.beforeResolve(async (to, from) => {
  if (to.meta.auth) {
    if (!isLogin()) {
      return { name: 'Home' };
    }
  }
});

export default router;
