import { Injectable } from '@kaokei/use-vue-service';
import { DaoService } from './dao.service';

@Injectable()
export class WorksListService {
  public pageNum = 1;
  public pageSize = 10;
  public provinceId = 1;
  public userName = '';

  public queryResult?: any;
  public list?: any[];
  public currentWork?: any;

  public get renderList() {
    if (this.list) {
      const ret = [];
      for (let i = 0; i < this.list.length; i += 4) {
        ret.push(this.list.slice(i, i + 4));
      }
      return ret;
    }
  }

  constructor(public daoService: DaoService) {}

  public search() {
    this.daoService
      .getCreationList({
        pageNum: this.pageNum,
        pageSize: this.pageSize,
        provinceId: this.provinceId,
        userName: this.userName,
      })
      .then(res => {
        this.queryResult = res || {};
        this.list = this.queryResult.list || [];
      })
      .catch(() => {
        this.queryResult = {} as any;
        this.list = [];
      });
  }

  public searchFromFirstPage() {
    this.pageNum = 1;
    this.search();
  }

  public goToPrevPage() {
    if (this.pageNum > 1) {
      this.pageNum -= 1;
      this.search();
    }
  }

  public goToNextPage() {
    this.pageNum += 1;
    this.search();
  }

  public setCurrentWork(work: any) {
    this.currentWork = work;
  }
}
