export const teacherPasswordReg =
  /^(?=.*?[0-9])(?=.*?[a-zA-Z])[a-zA-Z0-9]{6,16}$/;

export const studentPasswordReg = /^[a-zA-Z0-9]{6,16}$/;

// 手机号正则表达式
export const phonePattern = /^1\d{10}$/;

// 密码正则表达式
export const passwordPattern = /^[0-9a-zA-Z]{6,16}$/;

// 身份证正则表达式
// export const idCardPattern = /^[1-9]\d{5}(18|19|20|(3\d))\d{2}((0[1-9])|(1[0-2]))(([0-2][1-9])|10|20|30|31)\d{3}[0-9Xx]$/;
export const idCardPattern = /^[0-9a-zA-Z]{18}$/;

// 护照正则表达式
// export const passportPattern = /^([EK]\d{8}|(SE|DE|PE|MA)\d{7})$/;
export const passportPattern = /^[0-9a-zA-Z]{9}$/;

// 港澳通行证正则表达式
// export const gangAoPassPattern = /^[HMhm]{1}(\d{10}|\d{8})$/;
export const gangAoPassPattern = /^[0-9a-zA-Z]{9,11}$/;

// 在这里配置个性化的前端错误信息
// 当然这里是依据errCode来展示错误信息的
// 如果对于同一个errCode在不同的地方需要展示不同的错误信息，那么最好是让后端返回不同的错误信息。如果后端不好解决。
// 那么就需要前端使用X_DISABLE_ERROR禁止默认错误提示，然后在业务代码中自定义错误信息
export const ERROR_CODE_MESSAGE: Record<number, string> = {
  123123: '系统内部错误，请刷新重试',
};

// 这个是针对Select的下拉框数据格式
export const SEX = [
  { label: '男', value: 1 },
  { label: '女', value: 2 },
];
